---@diagnostic disable: undefined-global, lowercase-global, undefined-field, cast-local-type, need-check-nil
local function infomsg(msg) managers.chat:_receive_message(1, "INFO", msg, Color(255, 255, 212, 0) / 255, false) end


local function menu_save()
	local file = io.open(CTS.properties_savepath, "w+")
	if file then
		file:write(json.encode(CTS.properties))
		file:close()
	end
	
end
local function menu_read()
	local file = io.open(CTS.properties_savepath, "r")
	if file then
		for k, v in pairs(json.decode(file:read("*all")) or {}) do
			CTS.properties[k] = v
		end
		file:close()
	else
		menu_save()
	end
end


if RequiredScript == "lib/managers/menumanager" then
	if not _G.CTS then
		_G.CTS= _G.CTS or {}
		CTS.mod_path = ModPath .. "mod/"
		CTS.menu_path = ModPath .. "menu/"
		CTS.properties_savepath = SavePath .. "CTStproperties.txt"
		CTS.properties = {
			mod_enabled = true,
			red_part = 100,
			blue_part = 100,
			green_part = 0
			}
	end
end	
	

Hooks:Add("MenuManagerInitialize", "Menu_init_cts", function(menu_manager)
			

	MenuCallbackHandler.toggle_mod = function(self, item)
		CTS.properties.mod_enabled = (item:value() == "on") and true or false
	end

	MenuCallbackHandler.modify_red = function(self, item)
		CTS.properties.red_part = item:value()
	end
	MenuCallbackHandler.modify_green = function(self, item)
		CTS.properties.green_part = item:value()
	end
	MenuCallbackHandler.modify_blue = function(self, item)
		CTS.properties.blue_part = item:value()
	end
	
	MenuCallbackHandler.cts_save_menu_items = function(self, item)
		menu_save()
	end
	
	menu_read()
	MenuHelper:LoadFromJsonFile(CTS.menu_path .. "menu.txt", CTS, CTS.properties)
	
	end)
	

Hooks:Add("LocalizationManagerPostInit", "CTS:Localization", function(_l)
	_l:load_localization_file(CTS.menu_path .. "local.txt")
	end)
	
